// $Id: quickfile-shared.js,v 1.5 2004/10/22 11:15:24 Paul Tomlin Exp $

function qfGetPrefs ()
{
	var prefs =
	{
		debug:
		{
			enable: false,
			copynotmove: false,
		},
		
		search:
		{
			root: 'msgaccounts:/',
			casesensitive: false,
			expandspaces: true
		},
		
		shortcut:
		{
			key: 'q',
			modifiers: 'alt'
		},
		
		autoselectnext: false
	};

	// just get a handle on our part os the preferences, to be safe
	var prefsService = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch('quickfile.');

	try
	{
		prefs.debug.enable         = prefsService.getBoolPref('debug.enable');
		prefs.debug.copynotmove    = prefsService.getBoolPref('debug.copynotmove');

		prefs.search.root          = prefsService.getCharPref('search.root');
		prefs.search.casesensitive = prefsService.getBoolPref('search.casesensitive');
		prefs.search.expandspaces  = prefsService.getBoolPref('search.expandspaces');
		
		prefs.shortcut.key		   = prefsService.getCharPref('shortcut.key');
		prefs.shortcut.modifiers   = prefsService.getCharPref('shortcut.modifiers');
		
		prefs.autoselectnext	   = prefsService.getBoolPref('autoselectnext');
	}
	catch (e)
	{ /* ignored */ }
	
	return prefs;
};

function qfSetPrefs (prefs)
{
	// just get a handle on our part os the preferences, to be safe
	var prefsService = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch('quickfile.');
	
	prefsService.setBoolPref('debug.enable',         prefs.debug.enable);
	prefsService.setBoolPref('debug.copynotmove',    prefs.debug.copynotmove);
	
	prefsService.setCharPref('search.root',          prefs.search.root);
	prefsService.setBoolPref('search.casesensitive', prefs.search.casesensitive);
	prefsService.setBoolPref('search.expandspaces',  prefs.search.expandspaces);
	
	prefsService.setCharPref('shortcut.key', 		 prefs.shortcut.key);
	prefsService.setCharPref('shortcut.modifiers', 	 prefs.shortcut.modifiers);
	
	prefsService.setBoolPref('autoselectnext', 	 	 prefs.autoselectnext);
};

function qfGetFolderFromMessageURI (messageURI)
{
	var folder = null;
	
	try
	{
		// get a handle on a messenger instance
		var messenger = Components.classes['@mozilla.org/messenger;1']
							.createInstance(Components.interfaces.nsIMessenger);

		// what service deals with this message type					
		var messageService = messenger.messageServiceFromURI(messageURI)

		// the message header
		var hdr = messageService.messageURIToMsgHdr(messageURI)

		// what folder is the message in
		folder = hdr.folder;
	}
	catch (e)
	{
		// 
		alert(e);
	}

	return folder;
};

//
// qfSetShortcut
// Sets the shortcut used by quickfile-overlay 
function qfSetShortcut(key, modifiers)
{
	
};

